Title: Начало воссоздания Маджонга
Date: 2018-01-26 00:00
Category: News
Slug: mahjong-recreation-start
Lang: ru

![Screenshot][screenshot]

Эта статья описывает начало воссоздания игры Маджонг.

**План**

Мы начали воссоздание Маджонга с составления краткого плана реализации игровой механики с минимальной графикой:

* Загрузить раскладку
* Поместить фишки в позиции раскладки
* Различить фишки
* Реализовать выбор фишек
* Реализовать сравнение фишек

Как и любой другой план, этот выглядел вполне адекватно на первый взгляд. Тем не менее стоит начать разработку, как появляются новые детали. Этот план не был исключением. Ниже представлена пара проблем, вскрывшихся во время разработки.

**Проблема №1: предоставить бинарные ресурсы на поддерживаемых платформах**

Маджонг будет доступен для десктопа, мобилок и веба. Каждая платформа имеет ограничения на доступ к внешним файлам:

* Десктоп позволяет получить доступ почти к любому файлу
* Мобилки имеют ограниченный доступ к файловой системе
* Веб не имеет файловой системы

Мы решили сделать единый способ доступа к ресурсам путём их встраивания в исполняемый файл. Это решение привело к рождению проектов **mjin-resource** и **mahjong-data**.

Проект [mjin-resource][mjin-resource] служит для:

* перевода бинарных файлов в заголовочные файлы C с помощью утилиты **xxd**
* создания проекта MJIN, состоящего из сгенерированных заголовочных файлов, который собирается в статическую библиотеку
* предоставления интерфейса C++ для работы с ресурсами

Проект [mahjong-data][mahjong-data] является примером подобного проекта MJIN, ресурсы из которого использует проект [mahjong][mahjong].

**Проблема №2: загрузка изображений PNG на поддерживаемых платформах**

Для загрузки PNG мы используем соответствующий плагин OpenSceneGraph. Мы собрали его без проблем для десктопа. Сборка же для веба (Emscripten) оказалась сложнее: Emscripten содержит собственную версию **libpng**, которую сборочный скрипт OpenSceneGraph не видит. Нам пришлось обойти несколько проверок OpenSceneGraph, чтобы успешно собрать плагин для Emscripten.
Сборка плагина под мобилки ещё ждёт нас впереди. Как только мы разберёмся с плагином PNG на всех поддерживаемых платформах, мы опубликуем информацию о его сборке в новом самоучителе для [кросс-платформенного руководства OpenSceneGraph][osgcp_guide]. Нас уже [попросили это сделать][img_loading_issue].

**Разработка**

[Как вы знаете][lets-go], мы опубликовали кросс-платформенное руководство OpenSceneGraph для усиления сообщества OpenSceneGraph. Мы ценим обучение и любим делиться своими знаниями. Поэтому мы решили разрабатывать Маджонг небольшими воспроизводимыми частями, каждая из которых имеет уникальную внутреннюю версию. Эти версии доступны в [хранилище проекта mahjong][mahjong].

Мы также предоставляем [историю версий, каждая из которых сопровождается сборкой под веб][web-releases], для следующих целей:

* обучение: показать ход разработки изнутри
* доступность: предоставить старые версии для сравнения

**Текущее состояние игры Маджонг**

На момент написания этой статьи мы закончили реализацию выбора фишек. [Проверьте в своём браузере!][mahjong-version-tile-selection]

После реализации сравнения фишек мы опубликуем промежуточный результат для всех поддерживаемых платформ.

На этом мы заканчиваем описание начала воссоздания игры Маджонг.

[screenshot]: {attach}/images/2018-01-26-mahjong-recreation-start.png

[mjin-resource]: https://bitbucket.org/ogstudio/mjin-resource
[mahjong]: https://bitbucket.org/ogstudio-games/mahjong
[mahjong-data]: https://bitbucket.org/ogstudio-games/mahjong-data
[osgcp_guide]: https://github.com/ogstudio/openscenegraph-cross-platform-guide
[img_loading_issue]: https://github.com/OGStudio/openscenegraph-cross-platform-guide/issues/4
[lets-go]: {filename}/articles/2017-03-16_lets-go-ru.md
[web-releases]: http://ogstudio.github.io/game-mahjong
[mahjong-version-tile-selection]: https://ogstudio.github.io/game-mahjong/versions/010/mjin-player.html
