Title: Примеры и зависимости
Date: 2018-08-21 00:00
Category: News
Slug: examples-and-dependencies
Lang: ru

![Screenshot][screenshot]

Эта статья описывает два новых кросс-платформенных примера OpenSceneGraph
и изменение в работе с зависимостями.

**Примеры клиента HTTP и выбора узла сцены**

После окончания работы над [примером удалённой отладки][osgcpe-04] и
[сообщения об этом][article-2018-june] мы с удивлением обнаружили, что
безопасное соединение HTTPS между отлаживаемым приложением и брокером
отладки работало лишь в веб-версии примера. Десктопная и мобильная версии
работали лишь с помощью обычного соединения HTTP.

Т.к. текущая схема отладки не имеет авторизации, отладка по обычному соединению
HTTP не несёт никаких проблем. Однако, если мы хотим получить доступ к ресурсам,
расположенным на популярных сайтах вроде GitHub и BitBucket, мы обязаны
поддерживать HTTPS.

Необходимость поддержки HTTPS на каждой платформе побудила нас создать
[пример клиента HTTP][osgcpe-03]. Оказалось, что каждая платформа имеет
собственные правила по работе с HTTPS:

* веб (Emscripten) предоставляет Fetch API
* десктоп может использовать Mongoose с OpenSSL
* Android предоставляет HttpUrlConnection в языке Java
* iOS предоставляет NSURLSession в языке Objective-C

Необходимость поддержки разных языков на разных платформах привела к
созданию так называемого шаблона "хозяин-гость":

* гость (не привязан к платформе)
    * имеет сетевое представление
    * используется кросс-платформенным кодом на C++
* хозяин (определённая платформа)
    * опрашивает гостя на наличие ожидающих выполнение запросов
    * обрабатывает их
    * сообщает результат гостю

[Пример выбора узла сцены][osgcpe-05] оказался простым и не создал особых проблем.

**Изменение в работе с зависимостями**

Больше года нам приходилось жить со следующими [недостатками][osg-shortcomings]
сборки OpenSceneGraph официальными средствами:

* проблемы сборки под macOS ввиду использования определённых флагов сборки
* обход механизмов проверки зависимостей для использования PNG на Android
* принадлежность сборок iOS под симулятор и устройство к разным проектам Xcode
* ожидания в 20-30 минут для сборки OpenSceneGraph

Эти недостатки замедляли нас и усложняли разработку новых примеров. После того,
как мы десятый раз столкнулись с указанными проблемами в этом месяце, мы решили
исправить их раз и навсегда. Теперь мы собираем OpenSceneGraph как часть каждого
примера за 2-3 минуты без какой-либо магии. Также мы использовали этот подход
включения зависимости как части каждого примера для остальных библиотек вроде
Mongoose и libpng-android. 

Теперь без этих препятствий мы можем разрабатывать быстрее. Это значительно
облегчит создание следующей технической демонстрации Mahjong 2!

На этом мы заканчиваем описание двух новых кросс-платформенных примеров
OpenSceneGraph и изменения в работе с зависимостями.

[screenshot]: {attach}/images/2018-08-21-examples-and-dependencies.png

[article-2018-june]: {filename}/articles/2018-06-27-example-driven-development.md

[osgcpe-03]: https://github.com/OGStudio/openscenegraph-cross-platform-examples/tree/master/03.HTTPClient
[osgcpe-04]: https://github.com/OGStudio/openscenegraph-cross-platform-examples/tree/master/04.RemoteDebugging
[osgcpe-05]: https://github.com/OGStudio/openscenegraph-cross-platform-examples/tree/master/05.NodeSelection

[osg-shortcomings]: http://forum.openscenegraph.org/viewtopic.php?t=17443
