Title: Идеальные игры и средства для их разработки
Date: 2018-11-19 00:00
Category: News
Slug: ideal-gamedev
Lang: ru

![Screenshot][screenshot]

В этой статье мы обсудим, как выглядят идеальные видеоигра и инструмент для
разработки видеоигр, по нашему мнению.

**Вопросы**

Как вы знаете, [целями Opensource Game Studio][ogs-goals] являются:

* создание бесплатных инструментов для разработки видеоигр
* создание видеоигр с помощью этих инструментов
* создание самоучителей по разработке видеоигр

В этот раз мы решили задать себе пару простых вопросов:

* Какова идеальная видеоигра?
* Каков идеальный инструмент для разработки видеоигр?

Ниже представлены наши ответы.

**Ответ 1: Видеоигра идеальна, если она доставляет максимально возможное удовольствие**

Несмотря на то, что содержание является, пожалуй, самой важной частью,
удерживающей человека в игре, техническая сторона является транспортом для
доставки этого содержания. Существует немало технических проблем, которые
могут полностью испортить впечатление даже от превосходного содержания:

* недостаточная доступность: игра не идёт на оборудовании человека
* недостаточная оптимизация: игра тормозит
* критичные ошибки: игра падает время от времени

Мы тратим много сил, чтобы сделать наши игры доступными везде. Именно поэтому
мы выпустили [вторую демонстрацию OGS Mahjong 2][mahjong-demo2] лишь для веба:
т.к. вы можете запустить веб-версию практически где угодно.

**Ответ 2: Инструмент для разработки видеоигр идеален, если он позволяет создать игру мечты в кратчайшие возможные сроки**

Несмотря на то, что мы тратим много усилий на то, чтобы делиться своими
знаниями с помощью [руководств][osgcpg] и [самоучителей][osgcpe], мы осознаём,
что на работу с ними уходит много времени. Сейчас нельзя создать даже
простейшую [видеоигру на память][concentration] без выполнения следующих шагов:

* настроить окружение разработки
* написать код
* собрать приложение
* отладить приложение
* повторить шаги `написать-собрать-отладить` столько раз, сколько нужно

Написание кода и отладка, пожалуй, являются конечными формами входа и
выхода любого программного обеспечения, поэтому мы их не избежим. Однако,
мы можем полностью избавиться от шагов (или хотя бы значительно сократить их)
`настройки окружения разработки` и `сборки`. Именно на это мы и потратим
ближайшие месяцы.

Наша цель на ближайшие месяцы состоит в том, чтобы создать такой инструмент
разработки видеоигр, чтобы любой программист (или достаточно квалифицированный
человек) мог создать [видеоигру на память][concentration] с нуля за час.

На этом мы заканчиваем обсуждение, как выглядят идеальные видеоигра и
инструмент для разработки видеоигр, по нашему мнению.


[screenshot]: {attach}/images/2018-11-19-ideal-gamedev.png

[ogs-goals]: {filename}/pages/about-ru.md
[mahjong-demo2]: {filename}/articles/2018-10-02-mahjong-demo2-ru.md
[osgcpg]: https://github.com/OGStudio/openscenegraph-cross-platform-guide
[osgcpe]: https://github.com/OGStudio/openscenegraph-cross-platform-examples
[concentration]: https://en.wikipedia.org/wiki/Concentration_(game)
